VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cUSBWatcher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event DeviceChanged(ByVal devEvt As DEVICE_EVENTS)
Public Event DeviceArrival(ByVal devType As DEVICE_TYPE, sGUID As String, strExtra As String)
Public Event DeviceRemoveComplete(ByVal devType As DEVICE_TYPE, sGUID As String, strExtra As String)

Private m_hDevNotify As Long, m_Hwnd As Long

Public Sub BeginWatch(f As Form)
   m_Hwnd = f.hWnd
   Call RegisterDevNotify(m_Hwnd, m_hDevNotify)
   SubClass f
End Sub

Public Sub StopWatch()
   If m_hDevNotify Then
       Call UnregisterDeviceNotification(m_hDevNotify)
       m_hDevNotify = 0
   End If
   If oldWndProc Then UnSubClass
End Sub

Private Sub Class_Initialize()
   watcherPtr = ObjPtr(Me)
End Sub

Private Sub Class_Terminate()
   StopWatch
End Sub

Public Sub FireEvent(ByVal evt As DEVICE_EVENTS, Optional ByVal devType As DEVICE_TYPE = DBT_DEVTYP_UNKNOWN, _
                    Optional ByVal sGUID As String = "", Optional ByVal sExtra As String = "")
    If sGUID <> "" Then
       sGUID = sGUID & " (" & IFaceFromGuid(sGUID) & ")"
       Debug.Print sGUID
    End If
    If evt = DBT_DEVICEARRIVAL Then
       RaiseEvent DeviceArrival(devType, sGUID, sExtra)
    ElseIf evt = DBT_DEVICEREMOVECOMPLETE Then
       RaiseEvent DeviceRemoveComplete(devType, sGUID, sExtra)
    Else
       RaiseEvent DeviceChanged(evt)
    End If
End Sub

