VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Device monitor"
   ClientHeight    =   3915
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   13500
   LinkTopic       =   "Form1"
   ScaleHeight     =   3915
   ScaleWidth      =   13500
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lvEvents 
      Height          =   3135
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   12975
      _ExtentX        =   22886
      _ExtentY        =   5530
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Event"
         Object.Width           =   3881
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Device Type"
         Object.Width           =   5292
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "IFace Guid"
         Object.Width           =   5292
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Remarks"
         Object.Width           =   7056
      EndProperty
   End
   Begin VB.Menu mnuPopUp 
      Caption         =   "Pop"
      Visible         =   0   'False
      Begin VB.Menu mnuDetails 
         Caption         =   "Details"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents watcher As cUSBWatcher
Attribute watcher.VB_VarHelpID = -1

Private Sub Form_Load()
   Set watcher = New cUSBWatcher
   watcher.BeginWatch Me
End Sub

Private Sub Form_Resize()
   If Me.WindowState = vbMinimized Then Exit Sub
   lvEvents.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
   watcher.StopWatch
End Sub

Private Sub lvEvents_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   If Button = vbRightButton Then
      Dim li As Object
      Set li = lvEvents.HitTest(x, y)
      If li Is Nothing Then Exit Sub
      If li.SubItems(2) = "" Then Exit Sub
      PopupMenu mnuPopUp
   End If
End Sub

Private Sub mnuDetails_Click()
   Dim li As Object
   Set li = lvEvents.SelectedItem
   If li Is Nothing Then Exit Sub
   If li.SubItems(2) = "" Then Exit Sub
   Dim s As String
   s = li.SubItems(3)
   MsgBox GetUsbDetails(s), vbInformation, "Device details"
End Sub

Private Sub watcher_DeviceArrival(ByVal devType As DEVICE_TYPE, sGUID As String, strExtra As String)
    With lvEvents.ListItems.Add(, , "Device arrived")
        .SubItems(1) = GetDeviceType(devType)
        .SubItems(2) = sGUID
        .SubItems(3) = strExtra
    End With
End Sub

Private Sub watcher_DeviceChanged(ByVal devEvt As DEVICE_EVENTS)
    'lvEvents.ListItems.Add , , GetDeviceEvent(devEvt)
End Sub

Private Sub watcher_DeviceRemoveComplete(ByVal devType As DEVICE_TYPE, sGUID As String, strExtra As String)
    With lvEvents.ListItems.Add(, , "Device Remove Complete")
        .SubItems(1) = GetDeviceType(devType)
        .SubItems(2) = sGUID
        .SubItems(3) = strExtra
    End With
End Sub
